<template>

  <Head>
    <title>Customers - GreenK Cashier</title>
  </Head>
  <main class="c-main">
    <div class="container-fluid">
      <div class="fade-in">
        <div class="row">
          <div class="col-md-12">
            <div class="card border-0 rounded-3 shadow">
              <div class="card-header bg-primary text-white">
                <span class="font-weight-bold"><i class="fa fa-user-circle me-2"></i> CUSTOMERS</span>
              </div>
              <div class="card-body">
                <div class="row">
                  <!-- link view create customer -->
                  <div class="col-md-6">
                    <Link href="/apps/customers/create" v-if="hasAnyPermission(['customers.create'])"
                      class="btn btn-primary input-group-text">
                    <i class="fa fa-plus-circle me-2"></i> Create Customer
                    </Link>
                  </div>

                  <!-- form search customer -->
                  <div class="col-md-6">
                    <form @submit.prevent="handleSearch">
                      <div class="input-group mb-3">
                        <input type="text" v-model="search" class="form-control" placeholder="Search Customer...">
                        <button class="btn btn-primary input-group-text" type="submit">
                          <i class="fa fa-search me-2"></i>
                        </button>
                      </div>
                    </form>
                  </div>
                </div>

                <div class="table-responsive">

                  <table class="table table-hover">
                    <thead>
                      <tr>
                        <th scope="col" class="text-center">#</th>
                        <th scope="col">Full Name</th>
                        <th scope="col">Phone Number</th>
                        <th scope="col">Address</th>
                        <th scope="col" style="width:20%" class="text-center">Actions</th>
                      </tr>
                    </thead>
                    <tbody>
                      <tr v-for="(customer, index) in customers.data" :key="index">
                        <td class="fw-bold text-center">
                          {{ ++index + (customers.current_page - 1) *
                          customers.per_page }}
                        </td>
                        <td>{{ customer.name }}</td>
                        <td>0{{ customer.phone_number }}</td>
                        <td>{{ customer.address }}</td>
                        <td class="text-center">
                          <!-- link view edit -->
                          <Link :href="`/apps/customers/${customer.id}/edit`"
                            v-if="hasAnyPermission(['customers.edit'])"
                            class="btn btn-info btn-sm mb-md-0 mx-1 mb-2 mb-sm-0"><i
                            class="fa fa-pencil-alt text-white fa-fw"></i>
                          </Link>
                          <!-- button delete -->
                          <button @click.prevent="destroy(customer.id)" v-if="hasAnyPermission(['customers.delete'])"
                            class="btn btn-danger btn-sm mx-1"><i class="fa fa-trash fa-fw"></i>
                          </button>
                        </td>
                      </tr>
                    </tbody>
                  </table>
                </div>
                <!-- pagination -->
                <Pagination :links="customers.links" align="end" />
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </main>
</template>

<script>
//import layout
import LayoutApp from '../../../Layouts/App.vue';

//import component pagination
import Pagination from '../../../Components/Pagination.vue';

//import Heade and Link from Inertia
import { Head, Link } from '@inertiajs/vue3';

// import ref from vue
import { ref } from 'vue';

// import inertia adapter
import { router } from '@inertiajs/vue3';

// import sweet alert2
import Swal from 'sweetalert2';

export default {
  // layout
  layout: LayoutApp,

  // register components
  components: {
    Head,
    Link,
    Pagination
  },

  // props
  props: {
    customers: Object,
  },

  // composition api
  setup() {
    // define state search
    const search = ref('' || (new URL(document.location)).searchParams.get('q'));

    // define method search
    const handleSearch = () => {
      router.get('/apps/customers', {
        // send params "q" with value from state "search"
        q: search.value,
      })
    }

    // define method destroy
    const destroy = (id) => {
      Swal.fire({
        title: 'Are you sure?',
        text: "You won't be able to revert this!",
        icon: 'warning',
        showCancelButton: true,
        confirmButtonColor: '#3085d6',
        cancelButtonColor: '#d33',
        confirmButtonText: 'Yes, delete it!'
      })
        .then((result) => {
          if (result.isConfirmed) {
            router.delete(`/apps/customers/${id}`);
            Swal.fire({
              title: 'Deleted!',
              text: 'Customer has been deleted.',
              icon: 'success',
              timer: 2000,
              showConfirmButton: false,
            });
          }
        })
    }

    // return
    return {
      search,
      handleSearch,
      destroy
    }
  }
}
</script>

<style>

</style>